# Project objects

Request and Response schemas for `/project` endpoints.


## Project request {#projectrequest}

A project request determines the type of passes you can create and the types of barcode your passes will use.

[Jump to examples ↓](#projectrequest-examples)

- **`description`** `string` **REQUIRED**

  A description for the project.

- **`name`** `string` **REQUIRED**

  The name of your project.

- **`projectType`** `string` **REQUIRED**

  The type of pass the template supports; matches the `type` setting for the parent project.


  Possible values: `memberCard`, `coupon`, `boardingPass`, `eventTicket`, `generic`, `loyalty`, `giftCard`

- **`settings`** `object`

  Contains barcode information for the project.

  **OBJECT PROPERTIES**

  - **`barcode_alt_text`** `string`

    Alternate text for the barcode. This text assists the user if they hover over the barcode or the barcode doesn't render.

  - **`barcode_default_value`** `string`

    The default value for the barcode. If you do not set a new value when creating a pass, the pass will use this value.


  - **`barcode_encoding`** `string`

    Barcode encoding is set at the project level and inherited by templates
and passes.


    Possible values: `iso-8859-1`

  - **`barcode_label`** `string`

    The title of the barcode; appears above the barcode in templates. You can change this value when creating or updating templates or passes.


  - **`barcode_type`** `string`

    The format of the barcode supported by the project and resulting passes.

    Possible values: `pdf417`, `aztec`, `code128`, `qr`, `upc-a`, `ean-13`, `code-39`


**Used in:**

- [Create project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#createproject)
- [Create project with external ID]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#createprojectexternalid)
- [Duplicate project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#duplicateproject)
- [Get project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#getproject)
- [List projects]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#listprojects)
- [Update project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#updateproject)

**Examples**

*Example project request*

```json
{
  "name": "Aztec Barcode",
  "projectType": "loyalty",
  "description": "Aztec Barcode",
  "settings": {
    "barcode_alt_text": "123json=456789",
    "barcode_label": "Member ID",
    "barcode_default_value": "123456789",
    "barcode_encoding": "iso-8859-1",
    "barcode_type": "pdf417"
  }
}

```

---

## Project response {#projectpayload}

A project response includes all fields in a project request, along with identifiers for the project and a list of templates created within the project.

[Jump to examples ↓](#projectpayload-examples)

**All of:**

- [Project request]({{< ref "/developer/rest-api/wallet/schemas/project-objects/" >}}#projectrequest)

  A project request determines the type of passes you can create and the types of barcode your passes will use.

  - **`contextId`** `string`

    Append this value to `go.urbanairship.com/projects/` to access your project.


    Read only: true

  - **`createdAt`** `string`

    The date and time when the item was created.

    Format: `date-time`

    Read only: true

  - **`externalId`** `string`

    The custom, external identifier of the project. This key only appears if you assigned an external ID to the project.

  - **`id`** `integer`

    The identifier for the project, used to reference the project in other payloads.

    Read only: true

  - **`templates`** `array`

    An array of templates belonging to the project. When creating a new project, this array is empty.

    Read only: true

    **All of:**

      - **`createdAt`** `string`

        The date and time when the item was created.

        Format: `date-time`

        Read only: true

      - **`id`** `integer`

        The identifier for the template. You can recall the template by ID in other operations.

        Read only: true

      - **`updatedAt`** `string`

        The date and time when the item was last updated.

        Format: `date-time`

        Read only: true

    - [General template headers]({{< ref "/developer/rest-api/wallet/schemas/others/" >}}#templaterequestheaders)

      Meta information about templates; this object appears on all templates and identifies templates associated with a project.


  - **`updatedAt`** `string`

    The date and time when the item was last updated.

    Format: `date-time`

    Read only: true


**Used in:**

- [Create project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#createproject)
- [Create project with external ID]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#createprojectexternalid)
- [Duplicate project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#duplicateproject)
- [Get project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#getproject)
- [List projects]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#listprojects)
- [Update project]({{< ref "/developer/rest-api/wallet/operations/projects/" >}}#updateproject)

**Examples**

*Example project response*

```json
{
  "updatedAt": "2013-06-27T20:55:06.000Z",
  "id": "12345",
  "contextId":"myvWLcm8QN3Iq2K4fXT-Bv",
  "templates": [
    {
      "vendor": "Apple",
      "projectType": "loyalty",
      "projectId": "12345",
      "type": "Store Card",
      "vendorId": "1",
      "deleted": "False",
      "id": "1234",
      "updatedAt": "2013-06-27T20:58:05.000Z",
      "description": "Template 1",
      "createdAt": "2013-06-27T20:51:09.000Z",
      "name": "Template 1",
      "disabled": "False"
    }
  ],
  "description": "Aztec Barcode",
  "createdAt": "2013-06-27T20:51:02.000Z",
  "settings": {
    "barcode_alt_text": "123456789",
    "barcode_default_value": "123456789",
    "barcode_encoding": "iso-8859-1",
    "barcode_label": "Member ID",
    "barcode_type_text": "Aztec",
    "barcode_type": "aztec"
  },
  "name": "Aztec Barcode",
  "projectType": "loyalty"
}

```

---

